on 1:LOAD:{
  set %leech.status 0
  echo *** Wired Script fserv leecher loaded!.
}

on 1:start:{
  echo Leech v1.0: Loaded
  set %leech.status 0
}

on 1:TEXT:*#*:*:{
  if (%leech.status != 1) { halt }
  set %leech.full $strip($1-)
  set %leech.part $strip($1)
  set %leech.num $mid(%leech.part,2,$calc($len(%leech.part)-1))

  if (%leech.num isnum 1-9999) {
    set %leech.line $strip($nick) : $strip($1) : $strip($2-)
    set %leech.match $strip($nick) : $strip($1)
    {
      set %leech.token $line(@leech,0)
      :top
      if (%leech.token == 0 ) { aline @leech $strip($nick) : $strip($1) : $strip($2-) | halt }
      if (%leech.match isin $line(@leech,%leech.token)) {
        if ($line(@leech,%leech.token) == %leech.line) { 
          if (%leech.debug.showcopy == 1) { aline @errors COPY: $line(@leech,%leech.token) } 
          halt
        }
        if (%leech.debug.replaced == 1) { aline @errors REPLACED: $line(@leech,%leech.token) }
        rline @leech %leech.token $strip($nick) : $strip($1) : $strip($2-))
        halt
      }
      dec %leech.token
      goto top
    }
  }
  else { if (%leech.debug.errors == 1) { aline @errors ERROR: $nick : %leech.full } }
}

on 1:NOTICE:*#*:*:{
  if (%leech.status != 1) { halt }
  set %leech.full $strip($1-)
  set %leech.part $strip($1)
  set %leech.num $mid(%leech.part,2,$calc($len(%leech.part)-1))

  if (%leech.num isnum 1-9999) {
    set %leech.line $strip($nick) : $strip($1) : $strip($2-)
    set %leech.match $strip($nick) : $strip($1)
    {
      set %leech.token $line(@leech,0)
      :top
      if (%leech.token == 0 ) { aline @leech $strip($nick) : $strip($1) : $strip($2-) | halt }
      if (%leech.match isin $line(@leech,%leech.token)) {
        if ($line(@leech,%leech.token) == %leech.line) { 
          if (%leech.debug.showcopy == 1) { aline @errors COPY: $line(@leech,%leech.token)  } 
          halt
        }
        if (%leech.debug.replaced == 1) { aline @errors REPLACED: $line(@leech,%leech.token) }
        rline @leech %leech.token $strip($nick) : $strip($1) : $strip($2-))
        halt
      }
      dec %leech.token
      goto top
    }
  }
  else {  if (%leech.debug.errors == 1) { aline @errors ERROR: $nick : %leech.full } }
}

menu @leech {
  lbclick:{
    set %leech $sline(@leech,1)
    set %leech.temp $pos(%leech,:,1)
    set %leech.temp $calc(%leech.temp - 2)
    set %leech.from $left(%leech, %leech.temp)
    set %leech.temp $calc(%leech.temp + 4)
    set %leech.temp2 $pos(%leech,:,2)
    set %leech.temp2 $calc(%leech.temp2 - %leech.temp)
    set %leech.file $mid(%leech,%leech.temp,%leech.temp2)
  }
  dclick:{
    echo *** Leeching file %leech.file from %leech.from
    /ctcp %leech.from xdcc send %leech.file
    /ctcp %leech.from cdcc send %leech.file
  }
  Leech Settings
  .On:window -klns @leech | set %leech.status 1 | if (%leech.debug == 1) { window -knls @errors } | echo *** Leech: Starting Up...
  .Off:set %leech.status 0 | echo *** Leech: Stopping...
  .Close:set %leech.status 0 | window -c @leech | echo *** Leech: Stoped & Closed Leech Window
  .Clear:dline @leech 1- | echo *** Leech: Clearing Window
  .Leech Info:echo Wired Script fserv leecher v1.0
  .Leech Status:{
    if (%leech.status == 1) { echo *** Leech is ON } 
    else { echo *** Leech is OFF }
  }
  -
  Get
  . XDCC:ctcp $strip(%leech.from) xdcc send $strip(%leech.file) | echo *** Leech: Getting: %leech.file from %leech.from
  .CDCC:ctcp $strip(%leech.from) cdcc send $strip(%leech.file) | echo *** Leech: Getting: %leech.file from %leech.from
  List
  .XDCC:ctcp $strip(%leech.from) xdcc list
  .CDCC:ctcp $strip(%leech.from) cdcc list
}

menu @errors {
  Show Errors
  .On:set %leech.debug.errors 1 | set %leech.debug 1 | echo *** Leech: Debug: Showing Errors
  .Off:set %leech.debug.errors 0 | set %leech.debug 0 | echo *** Leech: Debug: Not Showing Errors
  Show Replaced
  .On:set %leech.debug.replaced 1 | set %leech.debug 1 | echo *** Leech: Debug: Showing Replaced Lines
  .Off:set %leech.debug.replaced 0 | set %leech.debug 1 | echo *** Leech: Debug: Not Showing Replaced Lines
  Show Copies
  .On:set %leech.debug.showcopy 1 | set %leech.debug 1 | echo *** Leech: Debug: Showing Copies
  .Off:set %leech.debug.showcopy 0 | set %leech.debug 1 | echo *** Leech: Debug: Not Showing Errors
  Show All
  .On:{
    set %leech.debug 1
    set %leech.debug.errors 1
    set %leech.debug.replaced 1
    set %leech.debug.showcopy 1
    echo *** Leech: Debug: Turning All Debugging On
  }
  .Off:{
    set %leech.debug 0
    set %leech.debug.errors 0
    set %leech.debug.replaced 0
    set %leech.debug.showcopy 0
    echo *** Leech: Debug: Turning All Debugging Off
  }
  Clear:dline @errors 1- | echo *** Leech: Clearing Debug Screen
}

menu channel,status {
  Leech
  .On:window -klns @leech | set %leech.status 1 | if (%leech.debug == 1) { window -knls @errors } | echo *** Leech: Starting Up...
  .Off:set %leech.status 0 | echo *** Leech: Stopping...
  .Close:set %leech.status 0 | window -c @leech | echo *** Leech: Stoped & Closed Leech Window
  .Clear:dline @leech 1- | echo *** Leech: Clearing Window
  .Leech Info:echo Wired Script fserv leecher v1.0
  .Leech Status:{
    if (%leech.status == 1) { echo *** Leech is ON } 
    else { echo *** Leech is OFF }
  }
  .Debug
  ..Show Errors
  ...On:set %leech.debug.errors 1 | set %leech.debug 1 | echo *** Leech: Debug: Showing Errors
  ...Off:set %leech.debug.errors 0 | set %leech.debug 0 | echo *** Leech: Debug: Not Showing Errors
  ..Show Replaced
  ...On:set %leech.debug.replaced 1 | set %leech.debug 1 | echo *** Leech: Debug: Showing Replaced Lines
  ...Off:set %leech.debug.replaced 0 | set %leech.debug 1 | echo *** Leech: Debug: Not Showing Replaced Lines
  ..Show Copies
  ...On:set %leech.debug.showcopy 1 | set %leech.debug 1 | echo *** Leech: Debug: Showing Copies
  ...Off:set %leech.debug.showcopy 0 | set %leech.debug 1 | echo *** Leech: Debug: Not Showing Errors
  ..Show All
  ...On:{
    set %leech.debug 1
    set %leech.debug.errors 1
    set %leech.debug.replaced 1
    set %leech.debug.showcopy 1
    echo *** Leech: Debug: Turning All Debugging On
  }
  ...Off:{
    set %leech.debug 0
    set %leech.debug.errors 0
    set %leech.debug.replaced 0
    set %leech.debug.showcopy 0
    echo *** Leech: Debug: Turning All Debugging Off
  }
  ..Clear:dline @errors 1- | echo *** Leech: Clearing Debug Screen
}
